
local bt = {speed=3/2}

local path = {}

local success = false

function bt.reset(maze,width,height)
	for i,v in ipairs(path) do
		path[i] = nil
	end
	path[1] = math.random(1,width)
	path[2] = math.random(1,height)
end

function bt.update(maze)
	if #path > 0 then
		local x,y = path[#path-1],path[#path]
		local t = {}
		if maze:getRaw(x-1,y) == 0 then t[#t+1] = {x-1,y} end
		if maze:getRaw(x,y-1) == 0 then t[#t+1] = {x,y-1} end
		if maze:getRaw(x+1,y) == 0 then t[#t+1] = {x+1,y} end
		if maze:getRaw(x,y+1) == 0 then t[#t+1] = {x,y+1} end
		if #t > 0 then
			success = true
			local c = math.random(1,#t)
			maze:merge(x,y,t[c][1],t[c][2])
			path[#path+1]=t[c][1]
			path[#path+1]=t[c][2]
		else
			if success or #path == 2 then
				local ox,oy = path[#path-3],path[#path-2]
				local l,u,r,d = maze:get(x,y)
				if maze:getRaw(x-1,y) ~= nil and not l then t[#t+1] = {x-1,y} end
				if maze:getRaw(x,y-1) ~= nil and not u then t[#t+1] = {x,y-1} end
				if maze:getRaw(x+1,y) ~= nil and not r then t[#t+1] = {x+1,y} end
				if maze:getRaw(x,y+1) ~= nil and not d then t[#t+1] = {x,y+1} end
				local c = math.random(1,#t)
				maze:merge(x,y,t[c][1],t[c][2])
			end
			success = false
			path[#path] = nil
			path[#path] = nil
		end
	end
end

return bt
