
local bt = {speed=3/1}

local path = {}
local extendChance = 0.1

function bt.reset(maze,width,height)
	path = {x=math.random(1,width),y=math.random(1,height)}
end

local surrounds = {
	{x=-1,y= 0},
	{x= 1,y= 0},
	{x= 0,y= 1},
	{x= 0,y=-1},
}

local function update(maze,path)
	if path.branch then
		for i,v in pairs(path.branch) do
			update(maze,v)
		end
	end
	for i,v in pairs(surrounds) do
		if math.random() < extendChance and maze:getRaw(path.x+v.x,path.y+v.y) == 0 then
			maze:merge(path.x,path.y,path.x+v.x,path.y+v.y)
			path.branch = path.branch or {}
			path.branch[#path.branch+1] = {x=path.x+v.x,y=path.y+v.y}
		end
	end
end

function bt.update(maze)
	update(maze,path)
end

return bt
