
local bt = {speed=3/2}

local path = {}

function bt.reset(maze,width,height)
	for i,v in ipairs(path) do
		path[i] = nil
	end
	path[1] = math.random(1,width)
	path[2] = math.random(1,height)
end

function bt.update(maze)
	if #path > 0 then
		local x,y = path[#path-1],path[#path]
		local t = {}
		if maze:getRaw(x-1,y) == 0 then t[#t+1] = {x-1,y} end
		if maze:getRaw(x,y-1) == 0 then t[#t+1] = {x,y-1} end
		if maze:getRaw(x+1,y) == 0 then t[#t+1] = {x+1,y} end
		if maze:getRaw(x,y+1) == 0 then t[#t+1] = {x,y+1} end
		if #t > 0 then
			local c = math.random(1,#t)
			maze:merge(x,y,t[c][1],t[c][2])
			path[#path+1]=t[c][1]
			path[#path+1]=t[c][2]
		else
			path[#path] = nil
			path[#path] = nil
		end
	end
end

return bt
