
local bt = {speed=1}

local merges = {}

local left,up,right,down = 1,2,4,8

local areas = {}

function bt.reset(maze,width,height)
	for i = 1, height do
		for j = 1, width do
			local a = 0
			if j ~= 1 then
				a=a+left
			end
			if i ~= 1 then
				a=a+up
			end
			if j ~= width then
				a=a+right
			end
			if i ~= height then
				a=a+down
			end
			maze:setRaw(j,i,a)
		end

	end
end

function bt.update(maze)
	if #merges > 0 then
		local c = math.random(1,#merges)
		local x1,y1,x2,y2 = unpack(merges[c])
		if maze:getRaw(x1,y1) == 0 or maze:getRaw(x2,y2) == 0 then
			maze:merge(x1,y1,x2,y2)
		end
		table.remove(merges,c)
	end
end

return bt
