
local bt = {speed=3/2}

local x,y

function bt.reset(maze,width,height)
	x = math.random(1,width)
	y = math.random(1,height)
end

local surrounds = {
	{x=-1,y= 0},
	{x= 1,y= 0},
	{x= 0,y= 1},
	{x= 0,y=-1},
}

function bt.update(maze)
	local ox,oy = x,y
	local d = surrounds[math.random(1,4)]
	if x+d.x >= 1 and y+d.y >= 1 and x+d.x <= maze.width and y+d.y <= maze.height then
		x=x+d.x
		y=y+d.y
		if maze:getRaw(x,y) == 0 or maze:getRaw(ox,oy) == 0 then
			maze:merge(x,y,ox,oy)
		end
	end
end

return bt
